{<                             Disk Index Creator                                        >}
{<                               by Peter Wayner                                         >}
{<                              Copyright 1991 Peter Wayner                      >}
{<                                                                                                  >}

{This is part of the software. See the copyright notice in IndexGlobals.p}
{for details. This file may not be distributed without this copyright notice}
{or separately from the other files. }

program Central;

{This is the central dispatching function that is used to test the baby before a }
{front end is added.}
uses
{$IFC UseProfiler}
Profiler, 
{$ENDC}
IndexGlobals, FileStructure, InAndOut, MemoryUnit;

{$IFC TestWordUsage}
procedure InitWordUsage;
var
i: integer;
begin
for i := 1 to MaxTreeDepth do
WordProfile[i] := 0;
NewWordCount := 0;
LocalNewWordCount := 0;
LocalWordCount := 0;
end;{InitWordUsage}
{$ENDC}
procedure FirstInitialization;
{This is to be run each time the program runs.}

begin
{$IFC TestWordUsage}
InitWordUsage;
{$ENDC}
{$IFC UseProfiler}
InitProfile;
{$ENDC}
{$IFC GraphHeapGrowth }
InitGraph;
{$ENDC}

end;{FirstInitialization}

procedure OperationLoop;
{Like an event one, more or less.}
var
result: boolean;
choice: integer;
begin
repeat
writeln('0=Quit, 1=CreateNewIndex, 2=LoadIndex,3=SaveIndex,4=RevertIndex,5=SaveAsAnother');
writeln('6=UpdateIndex,7=AddNewFile(s) 8 = LookupWord, 9=Save Drawing');

{$IFC UseProfiler}
writeln('99=ResetProfiler,100=DumpProfiler');
{$ENDC}
readln(choice);

case choice of
0: 
;{NOthing}
1: 
NewName;
2: 
result := OpenUp;{Error is trapped earlier.}
3: 
with TheIndex^ do
if OpenFileName = DefaultFileName then
SaveAsAnother{Well, we should get the name...}
else if WriteOutIndex(TheIndex, OpenFileName, OpenVref) then
;
4: 
Revert;
5: 
SaveAsAnother;
6: 
UpdateIndex;{(TheIndex)}
7: 
if GetScan then
;
8: 
LookUpShell;
9: 
SaveDrawing('DrawingWindowSave');


{$IFC UseProfiler}
99: 
ResetProfile;
100: 
DumpProfile;
{$ENDC}

end;
until choice = 0;


end;{OperationLoop}




begin
FirstInitialization;
OperationLoop;



end.